## radare2-cutter 1.7.4

=== docker/Makefile ===
SHELL := /bin/bash

# The directory of this file
DIR := $(shell echo $(shell cd "$(shell  dirname "${BASH_SOURCE[0]}" )" && pwd ))

# The local users UID/GID
LUID := $(shell id -u)
LGID := $(shell id -g)

# To mount a specific binary using BINARY=/absolute/path/to/binary
ifdef BINARY
    MOUNTFLAGS += -v $(BINARY):/home/r2/$(shell basename $(BINARY)):ro
    RUNFLAGS += /home/r2/$(shell basename $(BINARY))
endif

VERSION ?= latest
IMAGE_NAME ?= radareorg/cutter
CONTAINER_NAME ?= cutter

# This will output the help for each task
# thanks to https://marmelab.com/blog/2016/02/29/auto-documented-makefile.html
.PHONY: help

help: ## This help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)

.DEFAULT_GOAL := help

# Build the container
build: ## Build the container
	sudo docker build --rm -t $(IMAGE_NAME) .

build-nc: ## Build the container without caching
	sudo docker build --rm --no-cache -t $(IMAGE_NAME) .

run: ## Run container
	XSOCK=/tmp/.X11-unix && \
	XAUTH=$(shell mktemp /tmp/r2cutter_tmp.XXX.xauth) && \
	xauth nlist $$DISPLAY | sed -e 's/^..../ffff/' | xauth -f $$XAUTH nmerge - && \
	chmod 644 $$XAUTH && \
	touch $(DIR)/radare2rc && \
	mkdir -p $(DIR)/r2-config && \
	mkdir -p $(DIR)/sharedFolder && \
	sudo docker run \
		-it \
		--name $(CONTAINER_NAME) \
		--cap-add=SYS_PTRACE \
		-e DISPLAY=$$DISPLAY \
		-e XAUTHORITY=$$XAUTH \
		-e LOCAL_USER_ID=$(LUID) \
		-e LOCAL_GROUP_ID=$(LGID) \
		-v $$XSOCK:$$XSOCK:ro \
		-v $$XAUTH:$$XAUTH \
		$(MOUNTFLAGS) \
		-v $(DIR)/sharedFolder:/var/sharedFolder \
		-v $(DIR)/radare2rc:/home/r2/.radare2rc \
		-v $(DIR)/r2-config:/home/r2/.config/radare2 \
		$(IMAGE_NAME):$(VERSION) $(RUNFLAGS) && \
	rm $$XAUTH

get: ## Get the latest Cutter image
	sudo docker pull $(IMAGE_NAME):$(VERSION)

stop: ## Stop a running container
	sudo docker stop $(CONTAINER_NAME)

remove: ## Remove a (running) container
	sudo docker rm -f $(CONTAINER_NAME)

remove-image-force: ## Remove the latest image (forced)
	sudo docker rmi -f $(IMAGE_NAME):$(VERSION)

=== src/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.1)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(DisallowInSource)

option(CUTTER_ENABLE_JUPYTER "Enable Jupyter integration. Requires Python >= 3.3." ON)
option(CUTTER_ENABLE_QTWEBENGINE "Use QtWebEngine for in-app Jupyter Browser. Unused if CUTTER_ENABLE_JUPYTER=OFF." OFF)


# Parse Cutter.pro to get filenames
include(QMakeProParse)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Cutter.pro"
        "${CMAKE_CURRENT_BINARY_DIR}/Cutter.pro"
        COPYONLY) # trigger reconfigure if Cutter.pro changes
parse_qmake_pro("${CMAKE_CURRENT_BINARY_DIR}/Cutter.pro" CUTTER_PRO)
set(SOURCE_FILES ${CUTTER_PRO_SOURCES})
set(HEADER_FILES ${CUTTER_PRO_HEADERS})
set(UI_FILES ${CUTTER_PRO_FORMS})
set(QRC_FILES ${CUTTER_PRO_RESOURCES})
set(CUTTER_VERSION_MAJOR "${CUTTER_PRO_CUTTER_VERSION_MAJOR}")
set(CUTTER_VERSION_MINOR "${CUTTER_PRO_CUTTER_VERSION_MINOR}")
set(CUTTER_VERSION_PATCH "${CUTTER_PRO_CUTTER_VERSION_PATCH}")

set(CUTTER_VERSION_FULL "${CUTTER_VERSION_MAJOR}.${CUTTER_VERSION_MINOR}.${CUTTER_VERSION_PATCH}")

message(STATUS "version from Cutter.pro: ${CUTTER_VERSION_FULL}")
message(STATUS "sources from Cutter.pro: ${SOURCE_FILES}")
message(STATUS "headers from Cutter.pro: ${HEADER_FILES}")
message(STATUS "forms from Cutter.pro: ${UI_FILES}")
message(STATUS "resources from Cutter.pro: ${QRC_FILES}")

project(Cutter VERSION "${CUTTER_VERSION_FULL}")

set(CMAKE_CXX_STANDARD 11)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
find_package(Qt5 REQUIRED COMPONENTS Core Widgets Gui Svg Network)
if(CUTTER_ENABLE_JUPYTER AND CUTTER_ENABLE_QTWEBENGINE)
    find_package(Qt5 COMPONENTS WebEngineWidgets)
    if(NOT Qt5_FOUND)
        message(FATAL_ERROR "QtWebEngine could not be found which is required for the in-app Jupyter Browser.
If you do not want to enable this in-app Browser, re-run CMake with -DCUTTER_ENABLE_QTWEBENGINE=OFF.")
    endif()
    add_definitions(-DCUTTER_ENABLE_QTWEBENGINE)
endif()


if(WIN32)
    # use radare2 libraries from submodule on windows
    set(CUTTER_WIN32_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../cutter_win32")
    list(APPEND CMAKE_PREFIX_PATH "${CUTTER_WIN32_DIR}")

    if(CMAKE_SIZEOF_VOID_P EQUAL 8) # 64 bit
        list(APPEND CMAKE_LIBRARY_PATH "${CUTTER_WIN32_DIR}/radare2/lib64")
    else()
        list(APPEND CMAKE_LIBRARY_PATH "${CUTTER_WIN32_DIR}/radare2/lib32")
    endif()

    set(RADARE2_INCLUDE_DIRS "${CUTTER_WIN32_DIR}/radare2/include/libr" "${CUTTER_WIN32_DIR}/include")
endif()


find_package(Radare2 REQUIRED)
include_directories(${RADARE2_INCLUDE_DIRS})
link_directories(${RADARE2_LIBRARY_DIRS})

if(CUTTER_ENABLE_JUPYTER)
    find_package(PythonLibs 3.3)
    if(NOT PythonLibs_FOUND)
        message(FATAL_ERROR "Python >= 3.3 could not be found which is required for Jupyter integration.
If you do not want to enable Jupyter, re-run CMake with -DCUTTER_ENABLE_JUPYTER=OFF.")
    endif()

    include_directories(${PYTHON_INCLUDE_DIRS})
    add_definitions(-DCUTTER_ENABLE_JUPYTER)
endif()


if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
        OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    add_definitions(-Wall -Wextra)
endif()


message(STATUS "Building Cutter version ${CUTTER_VERSION_FULL}")


include(QMakeConfigureFile)
qmake_configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CutterConfig.h.in"
        "${CMAKE_CURRENT_BINARY_DIR}/CutterConfig.h")



add_executable(Cutter ${UI_FILES} ${QRC_FILES} ${SOURCE_FILES} ${HEADER_FILES})

target_link_libraries(Cutter Qt5::Core Qt5::Widgets Qt5::Gui Qt5::Svg Qt5::Network)
target_link_libraries(Cutter ${RADARE2_LIBRARIES})
if(CUTTER_ENABLE_JUPYTER)
    target_link_libraries(Cutter ${PYTHON_LIBRARIES})
    if(CUTTER_ENABLE_QTWEBENGINE)
        target_link_libraries(Cutter Qt5::WebEngineWidgets)
    endif()
endif()

=== src/meson_options.txt ===
option('enable_jupyter', type: 'boolean', value: false)
option('enable_webengine', type: 'boolean', value: false)

=== debian/changelog ===
radare2-cutter (1.7.4-2+rb2) UNRELEASED; urgency=medium

  * update

 -- Debian Security Tools <team+pkg-security@tracker.debian.org>  Fri, 22 Jan 2021 12:17:43 +0800

radare2-cutter (1.7.4-2) unstable; urgency=medium

  * Fix installation from build directory, fixing FTBFS on i386

 -- Hilko Bengen <bengen@debian.org>  Mon, 04 Feb 2019 12:01:29 +0100

radare2-cutter (1.7.4-1) unstable; urgency=low

  * Team upload
  * Initial release. (Closes: #910850)

 -- Hilko Bengen <bengen@debian.org>  Sat, 26 Jan 2019 00:54:03 +0100

=== debian/control ===
Source: radare2-cutter
Section: devel
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sebastian Reichel <sre@debian.org>
Build-Depends: cmake,
               debhelper (>= 12),
               pkg-config,
               python3-dev,
               qtbase5-dev,
               qtwebengine5-dev,
               libzip-dev,
               libqt5svg5-dev,
               libcapstone-dev,
               libradare2-dev,
               zlib1g-dev,
               libxxhash-dev,
Standards-Version: 4.3.0
Homepage: https://www.radare.org
Vcs-Browser: https://salsa.debian.org/pkg-security-team/radare2-cutter
Vcs-Git: https://salsa.debian.org/pkg-security-team/radare2-cutter.git

Package: radare2-cutter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         python3,
         python3-jupyter-client,
         python3-notebook,
         python3-ipykernel,
         python3-zmq,
Description: GUI for radare2 reverse engineering framework
 Cutter is a Qt based GUI for reverse engineering binaries, which makes
 use of the radare2 framework. Advanced users are expected to use the
 radare2 CLI tools instead, which are much more powerful.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure -- -DCUTTER_ENABLE_QTWEBENGINE=1

override_dh_auto_install:
	mkdir -p debian/radare2-cutter/usr/bin
	install -m755 ./obj-$(DEB_HOST_GNU_TYPE)/Cutter debian/radare2-cutter/usr/bin/
	mkdir -p debian/radare2-cutter/usr/share/applications
	install -m644 ./src/org.radare.Cutter.desktop debian/radare2-cutter/usr/share/applications
	mkdir -p debian/radare2-cutter/usr/share/icons/hicolor/scalable/apps
	install -m644 ./src/img/cutter.svg debian/radare2-cutter/usr/share/icons/hicolor/scalable/apps

## radare2-cutter 1.10.1

=== docker/Makefile ===
--- 
+++ 
@@ -17,6 +17,8 @@
 IMAGE_NAME ?= radareorg/cutter
 CONTAINER_NAME ?= cutter
 
+LOCAL_DEV ?= n
+
 # This will output the help for each task
 # thanks to https://marmelab.com/blog/2016/02/29/auto-documented-makefile.html
 .PHONY: help
@@ -28,10 +30,10 @@
 
 # Build the container
 build: ## Build the container
-	sudo docker build --rm -t $(IMAGE_NAME) .
+	sudo docker build --rm -t $(IMAGE_NAME) $(if $(LOCAL_DEV) == 'y',-f ./Dockerfile-dev ../,.)
 
 build-nc: ## Build the container without caching
-	sudo docker build --rm --no-cache -t $(IMAGE_NAME) .
+	sudo docker build --rm --no-cache -t $(IMAGE_NAME) $(if $(LOCAL_DEV) == 'y',-f ./Dockerfile-dev ../,.)
 
 run: ## Run container
 	XSOCK=/tmp/.X11-unix && \

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

if(POLICY CMP0074)
    cmake_policy(SET CMP0074 NEW)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(DisallowInSource)
include(Utils)

set(CUTTER_PYTHON_MIN 3.5)

option(CUTTER_USE_BUNDLED_RADARE2 "Use radare2 from src/radare2 submodule instead of searching for it on the system" OFF)
option(CUTTER_ENABLE_PYTHON "Enable Python integration. Requires Python >= ${CUTTER_PYTHON_MIN}." OFF)
option(CUTTER_ENABLE_PYTHON_BINDINGS "Enable generating Python bindings with Shiboken2. Unused if CUTTER_ENABLE_PYTHON=OFF." OFF)
option(CUTTER_ENABLE_CRASH_REPORTS "Enable crash report system. Unused if CUTTER_ENABLE_CRASH_REPORTS=OFF" OFF)
tri_option(CUTTER_ENABLE_KSYNTAXHIGHLIGHTING "Use KSyntaxHighlighting" AUTO)
tri_option(CUTTER_ENABLE_GRAPHVIZ "Enable use of graphviz for graph layout" AUTO)
option (option SHIBOKEN_EXTRA_OPTIONS "Extra options for shiboken generator")
set(CUTTER_EXTRA_PLUGIN_DIRS "" CACHE STRING "List of addition plugin locations")

if(NOT CUTTER_ENABLE_PYTHON)
    set(CUTTER_ENABLE_PYTHON_BINDINGS OFF)
endif()


# Parse Cutter.pro to get filenames
include(QMakeProParse)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Cutter.pro"
        "${CMAKE_CURRENT_BINARY_DIR}/Cutter.pro"
        COPYONLY) # trigger reconfigure if Cutter.pro changes
parse_qmake_pro("${CMAKE_CURRENT_BINARY_DIR}/Cutter.pro" CUTTER_PRO)
set(SOURCE_FILES ${CUTTER_PRO_SOURCES})
set(HEADER_FILES ${CUTTER_PRO_HEADERS})
set(UI_FILES ${CUTTER_PRO_FORMS})
set(QRC_FILES ${CUTTER_PRO_RESOURCES})
set(CUTTER_VERSION_MAJOR "${CUTTER_PRO_CUTTER_VERSION_MAJOR}")
set(CUTTER_VERSION_MINOR "${CUTTER_PRO_CUTTER_VERSION_MINOR}")
set(CUTTER_VERSION_PATCH "${CUTTER_PRO_CUTTER_VERSION_PATCH}")

set(CUTTER_VERSION_FULL "${CUTTER_VERSION_MAJOR}.${CUTTER_VERSION_MINOR}.${CUTTER_VERSION_PATCH}")

project(Cutter VERSION "${CUTTER_VERSION_FULL}")

set(CMAKE_CXX_STANDARD 11)

include_directories(core widgets common plugins)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
find_package(Qt5 REQUIRED COMPONENTS Core Widgets Gui Svg Network)

if(CUTTER_USE_BUNDLED_RADARE2)
    include(BundledRadare2)
    set(RADARE2_TARGET Radare2)
else()
    find_package(Radare2 REQUIRED)
    set(RADARE2_TARGET Radare2::libr)
endif()

if(CUTTER_ENABLE_PYTHON)
    find_package(PythonLibs ${CUTTER_PYTHON_MIN} REQUIRED)

    include_directories(${PYTHON_INCLUDE_DIRS})
    add_definitions(-DCUTTER_ENABLE_PYTHON)

    if(CUTTER_ENABLE_PYTHON_BINDINGS)
        find_package(PythonInterp REQUIRED)
        # 5.12.3 => 5.12
        if("${Qt5_VERSION}" MATCHES "^([0-9]+\\.[0-9]+)\\.[0-9]+")
            set(Shiboken2_VERSION_REQUIRED "${CMAKE_MATCH_1}")
        else()
            message(FATAL_ERROR "Failed to recognize Qt version")
        endif()
        find_package(Shiboken2 "${Shiboken2_VERSION_REQUIRED}" REQUIRED)
        find_package(PySide2 "${Shiboken2_VERSION_REQUIRED}" REQUIRED)

        get_target_property(PYSIDE_INCLUDE_DIR PySide2::pyside2 INTERFACE_INCLUDE_DIRECTORIES)
        list(GET PYSIDE_INCLUDE_DIR 0 PYSIDE_INCLUDE_DIR)
        include_directories(${PYSIDE_INCLUDE_DIR}
            ${PYSIDE_INCLUDE_DIR}/QtCore
            ${PYSIDE_INCLUDE_DIR}/QtGui
            ${PYSIDE_INCLUDE_DIR}/QtWidgets)

        add_definitions(-DCUTTER_ENABLE_PYTHON_BINDINGS)
    endif()
endif()

if(CUTTER_ENABLE_KSYNTAXHIGHLIGHTING)
    if(CUTTER_ENABLE_KSYNTAXHIGHLIGHTING STREQUAL AUTO)
        find_package(KF5SyntaxHighlighting)
        if(KF5SyntaxHighlighting_FOUND)
            set(KSYNTAXHIGHLIGHTING_STATUS ON)
        else()
            set(KSYNTAXHIGHLIGHTING_STATUS "OFF (KSyntaxHighlighting not found)")
        endif()
    else()
        find_package(KF5SyntaxHighlighting REQUIRED)
        set(KSYNTAXHIGHLIGHTING_STATUS ON)
    endif()
else()
    set(KSYNTAXHIGHLIGHTING_STATUS OFF)
endif()

if (CUTTER_ENABLE_GRAPHVIZ)
    if (CUTTER_ENABLE_GRAPHVIZ STREQUAL AUTO)
        find_package(Graphviz)
    else()
        find_package(Graphviz REQUIRED)
    endif()
    set (CUTTER_ENABLE_GRAPHVIZ ${Graphviz_FOUND})
endif()

message(STATUS "")
message(STATUS "Building Cutter version ${CUTTER_VERSION_FULL}")
message(STATUS "Options:")
message(STATUS "- Bundled radare2: ${CUTTER_USE_BUNDLED_RADARE2}")
message(STATUS "- Python: ${CUTTER_ENABLE_PYTHON}")
message(STATUS "- Python Bindings: ${CUTTER_ENABLE_PYTHON_BINDINGS}")
message(STATUS "- Crash Handling: ${CUTTER_ENABLE_CRASH_REPORTS}")
message(STATUS "- KSyntaxHighlighting: ${KSYNTAXHIGHLIGHTING_STATUS}")
message(STATUS "- Graphviz: ${CUTTER_ENABLE_GRAPHVIZ}")
message(STATUS "")


include(QMakeConfigureFile)
qmake_configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CutterConfig.h.in"
        "${CMAKE_CURRENT_BINARY_DIR}/CutterConfig.h")


if(CUTTER_ENABLE_PYTHON_BINDINGS)
    set(BINDINGS_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/bindings")
    set(BINDINGS_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/bindings")

    configure_file("${BINDINGS_SRC_DIR}/bindings.xml" "${BINDINGS_BUILD_DIR}/bindings.xml" COPYONLY) # trigger reconfigure if file changes

    execute_process(COMMAND "${PYTHON_EXECUTABLE}" "${BINDINGS_SRC_DIR}/src_list.py" cmake "${BINDINGS_BUILD_DIR}" OUTPUT_VARIABLE BINDINGS_SOURCE)

    set_property(SOURCE ${BINDINGS_SOURCE} PROPERTY SKIP_AUTOGEN ON)

    include_directories("${BINDINGS_BUILD_DIR}/CutterBindings")

    add_custom_command(OUTPUT ${BINDINGS_SOURCE}
            COMMAND Shiboken2::shiboken2 --project-file="${BINDINGS_BUILD_DIR}/bindings.txt" ${SHIBOKEN_EXTRA_OPTIONS}
            DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/bindings/bindings.xml" "${BINDINGS_BUILD_DIR}/bindings.txt"
            IMPLICIT_DEPENDS CXX "${CMAKE_CURRENT_SOURCE_DIR}/bindings/bindings.h"
            COMMENT "Generating Python bindings with shiboken2")
else()
    set(BINDINGS_SOURCE "")
endif()


if (TARGET Graphviz::GVC)
    list(APPEND SOURCE_FILES ${CUTTER_PRO_GRAPHVIZ_SOURCES})
    list(APPEND HEADER_FILES ${CUTTER_PRO_GRAPHVIZ_HEADERS})
endif()


if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
        OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    add_definitions(-Wall -Wextra)
    set_source_files_properties(${BINDINGS_SOURCE} PROPERTIES COMPILE_FLAGS -w)
endif()


add_executable(Cutter MACOSX_BUNDLE ${UI_FILES} ${QRC_FILES} ${SOURCE_FILES} ${HEADER_FILES} ${BINDINGS_SOURCE})
set_target_properties(Cutter PROPERTIES
        ENABLE_EXPORTS ON
        MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/macos/Info.plist")

if (TARGET Graphviz::GVC)
    target_link_libraries(Cutter Graphviz::GVC)
    target_compile_definitions(Cutter PRIVATE CUTTER_ENABLE_GRAPHVIZ)
endif()

if(CUTTER_ENABLE_CRASH_REPORTS)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
    target_link_libraries(Cutter Threads::Threads)
    
    add_definitions(-DCUTTER_ENABLE_CRASH_REPORTS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g ")
    if(DEFINED BREAKPAD_FRAMEWORK_DIR)
        include_directories("${BREAKPAD_FRAMEWORK_DIR}/Breakpad.framework/Headers")
        set_target_properties(Cutter PROPERTIES LINK_FLAGS "-Wl,-F${BREAKPAD_FRAMEWORK_DIR}")
        target_link_libraries(Cutter "-framework Breakpad")
    else()
        find_package(Breakpad REQUIRED)
        include_directories(${BREAKPAD_INCLUDE_DIRS})
        target_link_libraries(Cutter ${BREAKPAD_LINK_LIBRARIES})
    endif()
endif()

target_link_libraries(Cutter Qt5::Core Qt5::Widgets Qt5::Gui Qt5::Svg Qt5::Network)
target_link_libraries(Cutter ${RADARE2_TARGET})
if(CUTTER_ENABLE_PYTHON)
    target_link_libraries(Cutter ${PYTHON_LIBRARIES})
    if(CUTTER_ENABLE_PYTHON_BINDINGS)
        target_link_libraries(Cutter Shiboken2::libshiboken PySide2::pyside2)

        get_target_property(BINDINGS_INCLUDE_DIRS Cutter INCLUDE_DIRECTORIES)
        if(APPLE AND _qt5Core_install_prefix)
            list(APPEND BINDINGS_INCLUDE_DIRS "${_qt5Core_install_prefix}/include")
            list(APPEND BINDINGS_INCLUDE_DIRS "${_qt5Core_install_prefix}/include/QtCore")
            list(APPEND BINDINGS_INCLUDE_DIRS "${_qt5Core_install_prefix}/include/QtGui")
            list(APPEND BINDINGS_INCLUDE_DIRS "${_qt5Core_install_prefix}/include/QtWidgets")
        endif()
        list(APPEND BINDINGS_INCLUDE_DIRS ${Qt5Core_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS})
        list(APPEND BINDINGS_INCLUDE_DIRS ${Radare2_INCLUDE_DIRS})
        list(APPEND BINDINGS_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}")
        string(REPLACE ";" ":" BINDINGS_INCLUDE_DIRS "${BINDINGS_INCLUDE_DIRS}")

        qmake_configure_file("${BINDINGS_SRC_DIR}/bindings.txt.in" "${BINDINGS_BUILD_DIR}/bindings.txt")
    endif()
endif()

if(TARGET KF5::SyntaxHighlighting)
    target_link_libraries(Cutter KF5::SyntaxHighlighting)
    target_compile_definitions(Cutter PRIVATE CUTTER_ENABLE_KSYNTAXHIGHLIGHTING)
endif()

=== src/meson_options.txt ===
option('enable_python', type: 'boolean', value: true)
option('enable_python_bindings', type: 'boolean', value: true)

=== debian/changelog ===
radare2-cutter (1.10.1-3) unstable; urgency=medium

  * d/control: make supported architectures explicit
  * d/rules: set MAKE_BUILD_TYPE to remove debug fuzz
  * d/rules: export harding flags like suggested in the docs
  * d/rules: make crash reports opt-in (privacy)

 -- Robert Haist <rha@debian.org>  Thu, 27 Feb 2020 14:20:23 +0100

radare2-cutter (1.10.1-2) unstable; urgency=medium

  * d/control: Add dh-strip-nondeterminism to build reproducible
  * d/control: Point to the correct Cutter website (Closes: #921391)
  * This release and libradare2 in sid closes: #931172

 -- Robert Haist <rha@debian.org>  Wed, 26 Feb 2020 12:51:37 +0100

radare2-cutter (1.10.1-1) unstable; urgency=medium

  [ Hilko Bengen ]
  * New upstream version 1.8.0
  * New upstream version 1.8.1

  [ Samuel Henrique ]
  * Add salsa-ci.yml
  * Configure git-buildpackage for Debian

  [ Robert Haist ]
  * New upstream version 1.10.1
  * Added python support
  * Added syntax highlighting support
  * Added graphviz support
  * Bump standards version
  * Move to debhelper-compat

 -- Robert Haist <rha@debian.org>  Tue, 18 Feb 2020 23:02:09 +0100

=== debian/control ===
Source: radare2-cutter
Section: devel
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sebastian Reichel <sre@debian.org>, Robert Haist <rha@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-strip-nondeterminism,
               libcapstone-dev,
               libgraphviz-dev,
               libkf5syntaxhighlighting-dev,
               libqt5svg5-dev,
               libradare2-dev,
               libxxhash-dev,
               libzip-dev,
               pkg-config,
               python3-dev,
               qtbase5-dev,
               qtwebengine5-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://cutter.re
Vcs-Browser: https://salsa.debian.org/pkg-security-team/radare2-cutter
Vcs-Git: https://salsa.debian.org/pkg-security-team/radare2-cutter.git

Package: radare2-cutter
Architecture: amd64 arm64 armhf i386 mipsel
Depends: python3,
         python3-ipykernel,
         python3-jupyter-client,
         python3-notebook,
         python3-zmq,
         ${misc:Depends},
         ${shlibs:Depends}
Description: GUI for radare2 reverse engineering framework
 Cutter is a Qt based GUI for reverse engineering binaries, which makes
 use of the radare2 framework. Advanced users are expected to use the
 radare2 CLI tools instead, which are much more powerful.

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 
-DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
@@ -10,7 +10,10 @@
 	dh $@ --buildsystem=cmake --sourcedirectory=src
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCUTTER_ENABLE_QTWEBENGINE=1
+	dh_auto_configure -- \
+		-DCUTTER_ENABLE_PYTHON=ON \
+		-DCUTTER_ENABLE_CRASH_REPORTS=OFF \
+		-DCMAKE_BUILD_TYPE=Release
 
 override_dh_auto_install:
 	mkdir -p debian/radare2-cutter/usr/bin

=== debian/watch ===
version=3
opts=\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/cutter-$1\.tar\.gz/\
 https://github.com/radareorg/cutter/tags .*/v?(\d\S+)\.tar\.gz

## radare2-cutter 1.10.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 
 set(CMAKE_CXX_STANDARD 11)
 
-include_directories(core widgets common plugins)
+include_directories(core widgets common plugins menus)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)

=== debian/changelog ===
radare2-cutter (1.10.2-1) unstable; urgency=medium

  * New upstream version 1.10.2

 -- Robert Haist <rha@debian.org>  Tue, 10 Mar 2020 11:16:27 +0100

## radare2-cutter 1.12.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,18 +11,22 @@
 set(CUTTER_PYTHON_MIN 3.5)
 
 option(CUTTER_USE_BUNDLED_RADARE2 "Use radare2 from src/radare2 submodule instead of searching for it on the system" OFF)
+option(CUTTER_USE_ADDITIONAL_RADARE2_PATHS "Search radare2 in additional paths which are not part of default system library paths.\
+ Disable this option if you are linking against radare2 pacakged as proper system library or in a custom path and additional are paths causing problems." ON)
 option(CUTTER_ENABLE_PYTHON "Enable Python integration. Requires Python >= ${CUTTER_PYTHON_MIN}." OFF)
 option(CUTTER_ENABLE_PYTHON_BINDINGS "Enable generating Python bindings with Shiboken2. Unused if CUTTER_ENABLE_PYTHON=OFF." OFF)
 option(CUTTER_ENABLE_CRASH_REPORTS "Enable crash report system. Unused if CUTTER_ENABLE_CRASH_REPORTS=OFF" OFF)
+option(CUTTER_APPIMAGE_BUILD "Enable Appimage specific changes. Doesn't cause building of Appimage itself." OFF)
 tri_option(CUTTER_ENABLE_KSYNTAXHIGHLIGHTING "Use KSyntaxHighlighting" AUTO)
 tri_option(CUTTER_ENABLE_GRAPHVIZ "Enable use of graphviz for graph layout" AUTO)
-option (option SHIBOKEN_EXTRA_OPTIONS "Extra options for shiboken generator")
+set(SHIBOKEN_EXTRA_OPTIONS "" CACHE STRING "Extra options for shiboken generator")
 set(CUTTER_EXTRA_PLUGIN_DIRS "" CACHE STRING "List of addition plugin locations")
+option(CUTTER_ENABLE_DEPENDENCY_DOWNLOADS "Enable downloading of dependencies. Setting to OFF doesn't affect any downloads done by r2 build." OFF)
+option(CUTTER_PACKAGE_DEPENDENCIES "During install step include the third party dependencies." OFF)
 
 if(NOT CUTTER_ENABLE_PYTHON)
     set(CUTTER_ENABLE_PYTHON_BINDINGS OFF)
 endif()
-
 
 # Parse Cutter.pro to get filenames
 include(QMakeProParse)
@@ -44,13 +48,14 @@
 
 set(CMAKE_CXX_STANDARD 11)
 
-include_directories(core widgets common plugins menus)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTOUIC ON)
 set(CMAKE_AUTORCC ON)
 find_package(Qt5 REQUIRED COMPONENTS Core Widgets Gui Svg Network)
+
+include(CutterInstallDirs)
 
 if(CUTTER_USE_BUNDLED_RADARE2)
     include(BundledRadare2)
@@ -61,13 +66,13 @@
 endif()
 
 if(CUTTER_ENABLE_PYTHON)
+    find_package(PythonInterp REQUIRED)
     find_package(PythonLibs ${CUTTER_PYTHON_MIN} REQUIRED)
 
     include_directories(${PYTHON_INCLUDE_DIRS})
     add_definitions(-DCUTTER_ENABLE_PYTHON)
 
     if(CUTTER_ENABLE_PYTHON_BINDINGS)
-        find_package(PythonInterp REQUIRED)
         # 5.12.3 => 5.12
         if("${Qt5_VERSION}" MATCHES "^([0-9]+\\.[0-9]+)\\.[0-9]+")
             set(Shiboken2_VERSION_REQUIRED "${CMAKE_MATCH_1}")
@@ -142,8 +147,13 @@
 
     include_directories("${BINDINGS_BUILD_DIR}/CutterBindings")
 
+    set(SHIBOKEN_OPTIONS)
+    if (WIN32)
+        list(APPEND SHIBOKEN_OPTIONS --avoid-protected-hack)
+    endif()
+
     add_custom_command(OUTPUT ${BINDINGS_SOURCE}
-            COMMAND Shiboken2::shiboken2 --project-file="${BINDINGS_BUILD_DIR}/bindings.txt" ${SHIBOKEN_EXTRA_OPTIONS}
+            COMMAND Shiboken2::shiboken2 --project-file="${BINDINGS_BUILD_DIR}/bindings.txt" ${SHIBOKEN_OPTIONS} ${SHIBOKEN_EXTRA_OPTIONS}
             DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/bindings/bindings.xml" "${BINDINGS_BUILD_DIR}/bindings.txt"
             IMPLICIT_DEPENDS CXX "${CMAKE_CURRENT_SOURCE_DIR}/bindings/bindings.h"
             COMMENT "Generating Python bindings with shiboken2")
@@ -168,39 +178,64 @@
 add_executable(Cutter MACOSX_BUNDLE ${UI_FILES} ${QRC_FILES} ${SOURCE_FILES} ${HEADER_FILES} ${BINDINGS_SOURCE})
 set_target_properties(Cutter PROPERTIES
         ENABLE_EXPORTS ON
+        CXX_VISIBILITY_PRESET hidden
         MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/macos/Info.plist")
+target_compile_definitions(Cutter PRIVATE CUTTER_SOURCE_BUILD)
+
+set(CUTTER_INCLUDE_DIRECTORIES core widgets common plugins menus .)
+foreach(_dir ${CUTTER_INCLUDE_DIRECTORIES})
+    target_include_directories(Cutter PUBLIC
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${_dir}>
+        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/cutter/${_dir}>
+    )
+endforeach()
 
 if (TARGET Graphviz::GVC)
-    target_link_libraries(Cutter Graphviz::GVC)
+    target_link_libraries(Cutter PRIVATE Graphviz::GVC)
     target_compile_definitions(Cutter PRIVATE CUTTER_ENABLE_GRAPHVIZ)
 endif()
 
 if(CUTTER_ENABLE_CRASH_REPORTS)
     set(THREADS_PREFER_PTHREAD_FLAG ON)
     find_package(Threads REQUIRED)
-    target_link_libraries(Cutter Threads::Threads)
-    
+    target_link_libraries(Cutter PRIVATE Threads::Threads)
+
     add_definitions(-DCUTTER_ENABLE_CRASH_REPORTS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g ")
     if(DEFINED BREAKPAD_FRAMEWORK_DIR)
         include_directories("${BREAKPAD_FRAMEWORK_DIR}/Breakpad.framework/Headers")
         set_target_properties(Cutter PROPERTIES LINK_FLAGS "-Wl,-F${BREAKPAD_FRAMEWORK_DIR}")
-        target_link_libraries(Cutter "-framework Breakpad")
+        target_link_libraries(Cutter PRIVATE "-framework Breakpad")
     else()
         find_package(Breakpad REQUIRED)
         include_directories(${BREAKPAD_INCLUDE_DIRS})
-        target_link_libraries(Cutter ${BREAKPAD_LINK_LIBRARIES})
-    endif()
-endif()
-
-target_link_libraries(Cutter Qt5::Core Qt5::Widgets Qt5::Gui Qt5::Svg Qt5::Network)
-target_link_libraries(Cutter ${RADARE2_TARGET})
+        target_link_libraries(Cutter PRIVATE ${BREAKPAD_LINK_LIBRARIES})
+    endif()
+endif()
+
+target_link_libraries(Cutter PUBLIC Qt5::Core Qt5::Widgets Qt5::Gui PRIVATE  Qt5::Svg Qt5::Network)
+target_link_libraries(Cutter PUBLIC ${RADARE2_TARGET})
 if(CUTTER_ENABLE_PYTHON)
-    target_link_libraries(Cutter ${PYTHON_LIBRARIES})
+    if (WIN32)
+        # On windows some of the Python STABLE API functions are in seperate library
+        # which isn't added by CMake.
+        get_filename_component(_PYTHON_LIB_DIR ${PYTHON_LIBRARIES} DIRECTORY)
+        target_link_directories(Cutter PRIVATE ${_PYTHON_LIB_DIR})
+    endif()
+    target_link_libraries(Cutter PRIVATE ${PYTHON_LIBRARIES})
     if(CUTTER_ENABLE_PYTHON_BINDINGS)
-        target_link_libraries(Cutter Shiboken2::libshiboken PySide2::pyside2)
-
-        get_target_property(BINDINGS_INCLUDE_DIRS Cutter INCLUDE_DIRECTORIES)
+        target_link_libraries(Cutter PRIVATE Shiboken2::libshiboken PySide2::pyside2)
+
+        get_target_property(RAW_BINDINGS_INCLUDE_DIRS Cutter INCLUDE_DIRECTORIES)
+        set(BINDINGS_INCLUDE_DIRS "")
+        foreach(_dir ${RAW_BINDINGS_INCLUDE_DIRS})
+            string(REGEX REPLACE "\\$<BUILD_INTERFACE:(.*)>" "\\1" _dir ${_dir})
+            string(REGEX REPLACE "\\$<INSTALL_INTERFACE:(.*)>" "" _dir ${_dir})
+            if (NOT "${_dir}" STREQUAL "")
+                list(APPEND BINDINGS_INCLUDE_DIRS "${_dir}")
+            endif()
+        endforeach()
+
         if(APPLE AND _qt5Core_install_prefix)
             list(APPEND BINDINGS_INCLUDE_DIRS "${_qt5Core_install_prefix}/include")
             list(APPEND BINDINGS_INCLUDE_DIRS "${_qt5Core_install_prefix}/include/QtCore")
@@ -210,14 +245,50 @@
         list(APPEND BINDINGS_INCLUDE_DIRS ${Qt5Core_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS})
         list(APPEND BINDINGS_INCLUDE_DIRS ${Radare2_INCLUDE_DIRS})
         list(APPEND BINDINGS_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}")
-        string(REPLACE ";" ":" BINDINGS_INCLUDE_DIRS "${BINDINGS_INCLUDE_DIRS}")
+        if (NOT WIN32)
+            string(REPLACE ";" ":" BINDINGS_INCLUDE_DIRS "${BINDINGS_INCLUDE_DIRS}")
+        endif()
 
         qmake_configure_file("${BINDINGS_SRC_DIR}/bindings.txt.in" "${BINDINGS_BUILD_DIR}/bindings.txt")
+        add_compile_definitions(WIN32_LEAN_AND_MEAN)
     endif()
 endif()
 
 if(TARGET KF5::SyntaxHighlighting)
-    target_link_libraries(Cutter KF5::SyntaxHighlighting)
+    target_link_libraries(Cutter PRIVATE KF5::SyntaxHighlighting)
     target_compile_definitions(Cutter PRIVATE CUTTER_ENABLE_KSYNTAXHIGHLIGHTING)
 endif()
 
+if (CUTTER_APPIMAGE_BUILD)
+    target_compile_definitions(Cutter PRIVATE APPIMAGE)
+endif()
+
+include(Translations)
+
+# Install files
+install(TARGETS Cutter
+        EXPORT CutterTargets
+        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
+        BUNDLE DESTINATION "." # needs to be tested
+        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT Devel
+)
+install(EXPORT CutterTargets
+    NAMESPACE Cutter::
+    DESTINATION "${ConfigPackageLocation}"
+    COMPONENT Devel)
+install(FILES
+    cmake/CutterConfig.cmake
+    DESTINATION ${ConfigPackageLocation}
+    COMPONENT Devel
+)
+foreach(_file ${HEADER_FILES})
+    # Can't use target PUBLIC_HEADER option for installing due to multiple directories
+    get_filename_component(_header_dir "${_file}" DIRECTORY)
+    install (FILES "${_file}" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/cutter/${_header_dir}" COMPONENT Devel)
+endforeach()
+
+if(UNIX AND NOT APPLE)
+    install (FILES "img/cutter.svg"
+                DESTINATION "share/icons/hicolor/scalable/apps/")
+    install(FILES "org.radare.Cutter.desktop"
+        DESTINATION "share/applications"

=== debian/changelog ===
radare2-cutter (1.12.0-2) unstable; urgency=medium

  [ Arnaud Rebillout ]
  * Team upload
  * Add patches to build against radare2 5.5
  * Closes: #1009173 #1011350

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 29 Aug 2022 11:49:34 +0200

radare2-cutter (1.12.0-1) unstable; urgency=medium

  * New upstream version 1.12.0 (Closes: #976847)
  * d/control: add build dep qttools5-dev

 -- Robert Haist <rha@debian.org>  Mon, 25 Jan 2021 10:18:20 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                pkg-config,
                python3-dev,
                qtbase5-dev,
+               qttools5-dev,
                qtwebengine5-dev,
                zlib1g-dev
 Standards-Version: 4.5.0
